Bug Hunting Session
Bug 35943 - Improve speed for Refresh PIVOTTABLE
Summary: Improve speed for Refresh PIVOTTABLE
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
3.3.2 release
Hardware: x86 (IA32) All
: medium minor
Assignee: Kohei Yoshida
URL:
Whiteboard: target:4.0.0.0.beta2 target:4.1.0
Keywords: perf
Depends on:
Blocks:
 
Reported: 2011-04-04 02:01 UTC by admin
Modified: 2015-12-15 11:34 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Testfile with little demo data in it (169.80 KB, application/vnd.oasis.opendocument.spreadsheet)
2011-04-11 09:39 UTC, admin
Details

Note You need to log in before you can comment on or make changes to this bug.
Description admin 2011-04-04 02:01:39 UTC
Right click on the data pilot table and choose "refresh" blocks LO for a long time from some seconds to some minutes with 100% CPU usage for the used CPU. This applies to various Windows and Linux platforms powered by fairly recent processors. Running same file in the Monopoly-Spreadsheet works instant - no delay. Data size is usually between 1000 and maybe some 10000 data lines with about 40 rows.

This blocks the work. In lack of a solution i am forced to roll back to OO3.2, which was alredy kind of slow, but this is now absolutely not tolerable: i cannot expect this level of masochism from my 50 users here. DataPilot is one of the main uses of Spreadsheet here. With great regret: if this issue keeps beeing unsolved, this will be the end of life cycle for OO/LO for the entire company.
Comment 1 Jan Holesovsky 2011-04-07 10:14:12 UTC
Please provide the document that shows the behavior.  Thank you!
Comment 2 admin 2011-04-11 09:39:42 UTC
Created attachment 45482 [details]
Testfile with little demo data in it
Comment 3 Rainer Bielefeld Retired 2011-06-27 08:18:43 UTC
With reporter's sample and "LibreOffice 3.4.1RC1 - WIN7  Home Premium (64bit) German UI [OOO340m1 (Build:103)]" on 64 bit AMD Phenom II X4 955 Processor 3.2 GHz, 4GB RAM, Graphic Card: NVIDIA GeForce GT 430 Data Pilot tables in reporter's sample take few seconds for refresh. That's not unbearable, but annoying. Most Data Pilots I use take <<1s for refresh.

No idea what might cause the problem in this particular document.

OOo 3.4-dev (obsolete version) is not faster.

@reporter:
May I ask you to read  hints on <http://wiki.documentfoundation.org/BugReport> carefully? Detailed precise bug reports save more time than the best performance fix can do.
Can you please add information concerning 1 concrete test with OS and PC information and duration for a refresh of a named Data pilot table?
Comment 4 Rainer Bielefeld Retired 2011-07-06 22:52:31 UTC
Without further information I only see an enhancement request for more performance.
Comment 5 Kohei Yoshida 2011-07-07 08:56:44 UTC
You know, refreshing basically discards and re-populates the data cache, so it *is* an expensive operation.  Therefore it's not unreasonable for it to take a few seconds to complete.  Just FYI.
Comment 6 Kohei Yoshida 2012-03-19 12:44:28 UTC
I re-wrote a major portion of the pivot table implementation for 3.6.  The reload speed should be much faster than 3.5.  It will not be as fast as Excel though, since Excel has areas outside the pivot table also optimized, and you need that in order to match the speed of Excel.  But it should be noticeably faster than 3.5.
Comment 7 Not Assigned 2012-12-15 05:54:49 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "libreoffice-4-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a81040bed300b1110fdef051ffaa21588d62c94f&g=libreoffice-4-0

fdo#35943: Better performance with pivot table refresh.


It will be available in LibreOffice 4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Not Assigned 2012-12-15 05:55:08 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=696644dbfb25dea3030da92b2ab40cd70da90f05

fdo#35943: Better performance with pivot table refresh.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Kohei Yoshida 2012-12-15 05:55:34 UTC
Just did an additional performance improvement on top of what I mentioned in Comment 6.  Now the refresh speed with this document should be reasonable.  It only take a fraction of a second on my machine, which previously would take a few seconds.
Comment 10 Kohei Yoshida 2012-12-15 05:57:23 UTC
I can call this fixed now.
Comment 11 Robinson Tryon (qubit) 2015-12-15 11:34:20 UTC
Migrating Whiteboard tags to Keywords: (perf)
[NinjaEdit]